package org.processmining.niektax.attributebasedrefinement.plugin;

import org.deckfour.xes.model.XEvent;
import org.deckfour.xes.model.XLog;
import org.deckfour.xes.model.XTrace;
import org.deckfour.xes.model.impl.XAttributeLiteralImpl;
import org.processmining.contexts.uitopia.annotations.UITopiaVariant;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginVariant;

@Plugin(
		name = "Change All Lifecycles to Complete", 
		parameterLabels = {"Input Log"}, 
	    returnLabels = {"Output Log"}, 
	    returnTypes = { XLog.class }
		)
public class CompleteToStartPlugin{
	
	@UITopiaVariant(affiliation = UITopiaVariant.EHV, author = "N. Tax", email = "n.tax@tue.nl")
	@PluginVariant(variantLabel = "Change All Lifecycles to Complete", requiredParameterLabels = {0})
	public XLog bruteForceProcessTreeEpisode(PluginContext context, XLog log) {
		XLog clone = (XLog) log.clone();
		for(XTrace trace : clone){
			for(XEvent event : trace){
				event.getAttributes().put("lifecycle:transition", new XAttributeLiteralImpl("lifecycle:transition", "complete"));
			}
		}
		return clone;
	}
}