package org.processmining.niektax.attributebasedrefinement.plugin;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.processmining.niektax.temporalrelations.model.Boundary;

public class ManualAttributeRefinementParameters {
	String activityName;
	String attributeName;
	List<Boundary> boundaries;
	//Boolean setfilterOutsideBounds;
	
	public ManualAttributeRefinementParameters(){
		boundaries = new ArrayList<Boundary>();
		activityName = "";
		attributeName = "";
		//setfilterOutsideBounds = false;
	}
	
	public void setAttributeName(String name){
		attributeName = name;
	}
	
	public String getAttributeName(){
		return attributeName;
	}
	
	public void addBoundary(Boundary sb){
		boundaries.add(sb);
	}
	
	public void setFirstActivity(String a){
		activityName = a;
	}
	
	public Map<String, AttributeSplitBoundaries> obtainSplitBoundaries(){
		AttributeSplitBoundaries asb = new AttributeSplitBoundaries(activityName);
		for(Boundary b : boundaries)
			asb.add(b);
		Map<String, AttributeSplitBoundaries> asbMap = new HashMap<String, AttributeSplitBoundaries>();
		asbMap.put(activityName, asb);
		return asbMap;
	}
	
	public List<Boundary> getAreas(){
		return boundaries;
	}

}
