package org.processmining.niektax.attributebasedrefinement.plugin;

import org.deckfour.xes.model.XEvent;
import org.deckfour.xes.model.XLog;
import org.deckfour.xes.model.XTrace;
import org.deckfour.xes.model.impl.XAttributeLiteralImpl;
import org.processmining.contexts.uitopia.annotations.UITopiaVariant;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginVariant;

@Plugin(
		name = "Strip characters from concept:name that are not allowed in R variable names", 
		parameterLabels = {"Input Log"}, 
	    returnLabels = {"Output Log"}, 
	    returnTypes = { XLog.class }
		)
public class StripNonRVarNameCharsFromConceptNames{
	
	@UITopiaVariant(affiliation = UITopiaVariant.EHV, author = "N. Tax", email = "n.tax@tue.nl")
	@PluginVariant(variantLabel = "Strip characters from concept:name that are not allowed in R variable names", requiredParameterLabels = {0})
	public XLog bruteForceProcessTreeEpisode(PluginContext context, XLog log) {
		XLog clone = (XLog) log.clone();
		for(XTrace trace : clone){
			for(XEvent event : trace){
				String oldName = event.getAttributes().get("concept:name").toString();
				String newName = oldName.replace("-", "");
				newName = newName.replace(" ", "");
				newName = newName.replace("_", "");
				newName = newName.replace("'", "");
				//newName = newName.replaceAll("^\\d+", "");
				event.getAttributes().put("concept:name", new XAttributeLiteralImpl("concept:name", newName));
			}
		}
		return clone;
	}
}