package org.processmining.niektax.temporalrelations.model;

public class Boundary implements Comparable<Boundary>{
	private double left;
	private double right;
	
	public Boundary(double left, double right){
		this.left  = left;
		this.right = right;
	}
	
	public void setLeft(double left){
		this.left=left;
	}
	
	public void setRight(double right){
		this.right=right;
	}	
	
	public double getLeft(){
		return left;
	}
	
	public double getRight(){
		return right;
	}
	
	public int compareTo(Boundary o) {
		int value = 0;
		if(this.getLeft()==o.getLeft()){
			if(this.getRight()==o.getRight()){
				value = 0; 
			}else{
				if(this.getRight()>o.getRight()){
					value = 1;
				}else{
					value = -1;
				}
			}
		}else{
			if(this.getLeft()>o.getLeft()){
				value = 1;
			}else{
				value = -1;
			}
		}
		return value;
	}
	
	@Override
	public String toString(){
		return "["+left+"-"+right+")";
	}
	
	@Override
	public boolean equals(Object obj) {
		if(!(obj instanceof Boundary))
			return false;
		Boundary other = (Boundary) obj;
		return this.hashCode()==other.hashCode();
	}
	
    @Override
    public int hashCode() {
        return 37*(int)Double.doubleToLongBits(left)+(int)Double.doubleToLongBits(right);
    }
}
