package org.processmining.niektax.temporalrelations.model;

import java.util.Set;

import org.deckfour.xes.model.XLog;
import org.processmining.niektax.temporalrelations.model.dissimilarity.DissimilarityMetrics;
import org.processmining.niektax.temporalrelations.model.dissimilarity.DissimilarityResult;

import com.google.common.collect.Table;

public class DissimilaritySetterThread implements Runnable{
	private SplitBoundaries sb;
	private XLog log;
	private String row;
	private String column;
	private Table<String, String, SplitBoundaries> splitBoundaryTable;
	private DissimilarityMetrics dm;
	private static final String cnameConnector = "+";
	
	public DissimilaritySetterThread(SplitBoundaries sb, XLog log, String row, String column,Table<String, String, SplitBoundaries> splitBoundaryTable, DissimilarityMetrics dm){
		this.sb = sb;
		this.log = log;
		this.row = row;
		this.column = column;
		this.splitBoundaryTable = splitBoundaryTable;
		this.dm = dm;
	}
	
	public void run() {
		for(int i=0; i<sb.size();i++){
			for(int j=i+1; j<sb.size();j++){
				if(!sb.overlapping(i, j)){
					SplitBoundaries[] splitBoundariesArray = new SplitBoundaries[1];
					splitBoundariesArray[0] = new SplitBoundaries(sb.getFirstActivity(), sb.getSecondActivity());
					splitBoundariesArray[0].add(sb.get(i));
					splitBoundariesArray[0].add(sb.get(j));
					XLog splittedLog = (new SplitLogBySplitBoundaries(log, splitBoundariesArray, cnameConnector)).getSplittedLog();
					String[] columnStringParts = column.split("\\+");
					String basis = "";
					for(int n=0; n<columnStringParts.length-1; n++){
						basis += columnStringParts[n];
					}
					String a1 = basis+"_1+"+columnStringParts[columnStringParts.length-1];
					String a2 = basis+"_2+"+columnStringParts[columnStringParts.length-1];
					
					// TODO: dealen hardcoded threshold
					Set<DissimilarityResult> dissimilarity = TemporalRelationUtils.calculateActivityDissimilarity(splittedLog, a1, a2, column, dm, 0.95, 1.5, cnameConnector);
					System.out.println("Split "+column+" from source "+row+": 1= ["+sb.get(i).getLeft()+", "+sb.get(i).getRight()+"], 2= ["+sb.get(j).getLeft()+", "+sb.get(j).getRight()+"] dissimilarity= "+dissimilarity);

					splittedLog.clear();
					/* TODO: code weer repareren
					synchronized(splitBoundaryTable){
						if(sb.getDisimilarity(i)==null || dissimilarity > sb.getDisimilarity(i)){
							sb.setDissimilarity(i, dissimilarity);
							splitBoundaryTable.put(row, column, sb);
						}
						if(sb.getDisimilarity(j)==null || dissimilarity > sb.getDisimilarity(j)){
							sb.setDissimilarity(j, dissimilarity);
							splitBoundaryTable.put(row, column, sb);
						}
					}
					*/
				}
			}
		}
	}
}
