package org.processmining.niektax.temporalrelations.model;


public class SplitLogByManualSplitBoundariesParameters extends SplitLogBySplitBoundariesParameters{
	ManualSplitBoundaries msd;
	
	public SplitLogByManualSplitBoundariesParameters(String firstActivity, String secondActivity, ManualSplitBoundaries areas){
		super(firstActivity, secondActivity);
		this.msd =  areas;
	}
	
	public SplitLogByManualSplitBoundariesParameters(){
		super();
		this.msd = new ManualSplitBoundaries();
	}
	
	public ManualSplitBoundaries getAreas(){
		return msd;
	}

	public boolean addBoundary(Boundary area){
		if(area.getRight()<area.getLeft()){
			System.err.println("New area is not a proper area");
		}
		if(msd.within(area.getLeft()) || msd.within(area.getRight())){
			System.err.println("New area encapsulated in an existing area");
			return false;
		}
		if(!msd.sameSide(area.getLeft(), area.getRight())){
			System.err.println("New area encapsulates an existing area");
		}
		msd.add(area);
		return true;
	}
}
