package org.processmining.niektax.temporalrelations.model;

import java.util.Collection;
import java.util.LinkedList;
import java.util.List;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

import org.deckfour.xes.model.XLog;
import org.deckfour.xes.model.XTrace;

import com.google.common.collect.HashBasedTable;
import com.google.common.collect.Multiset;
import com.google.common.collect.Table;

public class TimeRelationsCalculator {
	public enum LookBack {ALL_THE_WAY, UNTIL_FIRST_SELF};
	private boolean calculationFinished = false;
	
	Table<String, String, Multiset<Long>> timeRelations;
	public TimeRelationsCalculator(XLog log, LookBack lookBack){
		ExecutorService executor = Executors.newFixedThreadPool(Runtime.getRuntime().availableProcessors());
		
		timeRelations = HashBasedTable.create();
		Table<String, String, Long> maxValues = HashBasedTable.create();
		Table<String, String, Long> minValues = HashBasedTable.create();

		for(XTrace t : log){
			TimeRelationsCalculatorThread trct = new TimeRelationsCalculatorThread(t, lookBack, timeRelations, maxValues, minValues);
			executor.execute(trct);
		}
		executor.shutdown();
		while(!executor.isTerminated()){
		
		}
		calculationFinished = true;
	}
	
	public Table<String, String, Multiset<Long>> getTimeRelations(){
		while(!calculationFinished){
			
		}
		return timeRelations;
	}
	
	public static
	<T extends Comparable<? super T>> List<T> asSortedList(Collection<T> c) {
	  List<T> list = new LinkedList<T>(c);
	  java.util.Collections.sort(list);
	  return list;
	}
}
