package org.processmining.niektax.temporalrelations.model;

import org.processmining.niektax.temporalrelations.model.dissimilarity.DissimilarityMetrics;

public class TimeSplitterParameters {
	private double minPtsRelative;
	private int    minPtsAbsolute;
	private double dissimilarityThreshold;
	private double oddsRatioThreshold;
	private double informationGainThreshold;
	private DissimilarityMetrics dissimilarityMetric;
	
	public TimeSplitterParameters(){
		
		// Set default values
		minPtsRelative           = 0.2;
		minPtsAbsolute           = 100;
		dissimilarityThreshold   = 0.05;
		oddsRatioThreshold       = 1.5;
		informationGainThreshold = 0.01;
		dissimilarityMetric      = DissimilarityMetrics.FISHER_TEST;
	}
	
	public void setMinPtsRelative(double minPtsRelative){
		this.minPtsRelative = minPtsRelative;
	}
	
	public double getMinPtsRelative(){
		return minPtsRelative;
	}
	
	public void setMinPtsAbsolute(int minPtsAbsolute){
		this.minPtsAbsolute = minPtsAbsolute;
	}
	
	public int getMinPtsAbsolute(){
		return minPtsAbsolute;
	}
	
	public void setDissimilarityThreshold(double dissimilarityThreshold){
		this.dissimilarityThreshold = dissimilarityThreshold;
	}
	
	public double getDissimilarityThreshold(){
		return dissimilarityThreshold;
	}
	
	public void setOddsRatioThreshold(double oddsRatioThreshold){
		this.oddsRatioThreshold = oddsRatioThreshold;
	}
	
	public double getOddsRatioThreshold(){
		return oddsRatioThreshold;
	}
	
	public void setInformationGainThreshold(double informationGainThreshold){
		this.informationGainThreshold = informationGainThreshold;
	}
	
	public double getRelativeInformationGainThreshold(){
		return informationGainThreshold;
	}
	
	public void setDissimilarityMetric(DissimilarityMetrics dm){
		this.dissimilarityMetric = dm;
	}
	
	public DissimilarityMetrics getDissimilarityMetric(){
		return dissimilarityMetric;
	}
}
