package org.processmining.niektax.temporalrelations.model;

import java.util.HashSet;
import java.util.Set;

public class UnorderedPair<T> {
    private final Set<T> set;

    public UnorderedPair(T a, T b) {
         set = new HashSet<T>();
         set.add(a);
         set.add(b);
    }

    public Set<T> getItems(){
    	return set;
    }
    
    @Override
    public boolean equals(Object other) {
    	if(!(other instanceof UnorderedPair))
    		return false;
    	UnorderedPair otherPair = (UnorderedPair) other;
    	boolean allContains = true;
    	for(Object otherElem : otherPair.getItems()){
    		if(!set.contains(otherElem))
    			allContains = false;
    	}
        return allContains;
    }

    @Override
    public int hashCode() {
    	int result = 0;
    	for(T elem : set){
    		result = 37 * result + elem.hashCode();
    	}
        return result;
    }
}
