package org.processmining.niektax.temporalrelations.model.dissimilarity;

import java.util.Map;
import java.util.Set;

import com.google.common.collect.Table;

public class HeuristicDissimilarity extends DissimilarityMetric {

	public HeuristicDissimilarity(String a, String b, String originalAb, Table<String, String, Integer> df, Table<String, String, Integer> ef, Table<String, String, Integer> ep, Table<String, String, Integer> cooc,Set<String> classifiedNames, Map<String, Integer> counts, double thresholdP, double thresholdOdds){
		super(a,b,originalAb,df,ef,ep,cooc,classifiedNames,counts,thresholdP,thresholdOdds);
	}
	
	public Set<DissimilarityResult> getParallelDissimilarity() {
		double par_dis_max = 0.0;
		for(String c : df.columnKeySet()){
			par_dis_max = Math.max(par_dis_max, (Math.abs(par_dis_sub(a,c,df)-par_dis_sub(b,c,df)))/counts.size());
		}
		return null;
	}

	public Set<DissimilarityResult> getDirectlyFollowsDissimilarity() {
		double df_dis_max = 0.0;
		for(String c : df.columnKeySet()){
			df_dis_max = Math.max(df_dis_max, Math.max(Math.abs(df_dis_sub(a,c,df)-df_dis_sub(b,c,df)), Math.abs(df_dis_sub(c,a,df)-df_dis_sub(c,b,df))));
		}
		return null;
	}

	public Set<DissimilarityResult> getDirectlyPrecedesDissimilarity() {
		// TODO Auto-generated method stub
		return null;
	}

	public Set<DissimilarityResult> getEventuallyFollowsDissimilarity() {
		double ltf_dis_max = 0.0;
		for(String c : ef.columnKeySet()){
			ltf_dis_max = Math.max(ltf_dis_max, Math.abs(ltd_dis_sub(a,c,ef,counts)-ltd_dis_sub(b,c,ef,counts)));
		}
		return null;
	}
	
	public Set<DissimilarityResult> getEventuallyPrecedesDissimilarity() {
		double ltp_dis_max = 0.0;
		for(String c : ef.columnKeySet()){
			ltp_dis_max = Math.max(ltp_dis_max, Math.abs(ltd_dis_sub(c,a,ef,counts)-ltd_dis_sub(c,b,ef,counts)));
		}
		return null;
	}
	
	private static double par_dis_sub(String a, String b, Table<String, String, Integer> df){
		double returnValue = 0.0;
		try{
			returnValue = ((double)(df.get(a, b)-df.get(b, a) - Math.abs(df.get(a, b)-df.get(b, a))))/(df.get(a, b)+df.get(b, a)+1);
		}catch(NullPointerException e){
			//TODO: research why this happens in rare occasions and fix it properly
			int ab = df.get(a, b) == null ? 0 : df.get(a, b);
			int ba = df.get(b, a) == null ? 0 : df.get(b, a);
			returnValue = ((double)(ab-ba - Math.abs(ab-ba)))/(ab+ba+1);
		}
		return returnValue;
	}
	
	private static double df_dis_sub(String a, String b, Table<String, String, Integer> df){
		double returnValue = 0.0;
		try{
			returnValue = ((double)Math.max(df.get(a, b)-df.get(b, a), 0))/(df.get(a, b)+df.get(b, a)+1);
		}catch(NullPointerException e){
			//TODO: research why this happens in rare occasions and fix it properly
			int ab = df.get(a, b) == null ? 0 : df.get(a, b);
			int ba = df.get(b, a) == null ? 0 : df.get(b, a);
			returnValue = ((double)Math.max(ab-ba, 0))/(ab+ba+1);
		}
		return returnValue;
	}
	
	private static double ltd_dis_sub(String a, String b, Table<String, String, Integer> ef, Map<String, Integer> counts){
		double returnValue = 0.0;
		try{
			returnValue = ((double)(2*ef.get(a, b)))/(counts.get(a)+counts.get(b)+1) - ((2*(double)Math.abs(counts.get(a)-counts.get(b)))/(counts.get(a)+counts.get(b)+1));
		}catch(NullPointerException e){
			//TODO: research why this happens in rare occasions and fix it properly
			int ab = ef.get(a, b) == null ? 0 : ef.get(a, b);
			int counta = counts.get(a) == null ? 0 : counts.get(a);
			int countb = counts.get(b) == null ? 0 : counts.get(b);
			returnValue = ((double)(2*ab))/(counta+countb+1) - ((2*(double)Math.abs(counta-countb))/(counta+countb+1));
		}
		//TODO: rare patch, nadenken over iets beters of theoretische onderbouwing
		if(returnValue<0)
			returnValue = 0;
		return returnValue;
	}

}
